__copy_from_user
Prev | User Space Memory Access | Next

## Name

__copy_from_user — Copy a block of data from user space, with less checking.

## Synopsis

`unsigned long __copy_from_user (` | void * | to,
| const void __user * | from,
| unsigned long | n`)`;

## Arguments

`to`

  Destination address, in kernel space.

`from`

  Source address, in user space.

`n`

  Number of bytes to copy.

## Context

User context only. This function may sleep.

## Description

Copy data from user space to kernel space. Caller must check the specified block with `access_ok` before calling this function.

Returns number of bytes that could not be copied. On success, this will be zero.

If some data could not be copied, this function will pad the copied data to the requested size using zero bytes.

An alternate version - `__copy_from_user_inatomic` - may be called from atomic context and will fail rather than sleep. In this case the uncopied bytes will *NOT* be padded with zeros. See fs/filemap.h for explanation of why this is needed.

Prev | Up | Next
__copy_to_user | Home | strlen_user